// Code generated by sqlc. DO NOT EDIT.
// versions:
//   sqlc v1.26.0
// source: upsert_peer.sql

package queries

import (
	"context"

	"github.com/jackc/pgx/v5/pgtype"
)

const upsertPeer = `-- name: UpsertPeer :exec

INSERT INTO peers.peers (
    id,
    name,
    manager_address
)
VALUES ($1, $2, $3)
ON CONFLICT (id) DO UPDATE
    SET name = EXCLUDED.name,
        manager_address = EXCLUDED.manager_address
`

type UpsertPeerParams struct {
	ID             string
	Name           pgtype.Text
	ManagerAddress pgtype.Text
}

// Copyright © VNG Realisatie 2024
// Licensed under the EUPL
func (q *Queries) UpsertPeer(ctx context.Context, arg *UpsertPeerParams) error {
	_, err := q.db.Exec(ctx, upsertPeer, arg.ID, arg.Name, arg.ManagerAddress)
	return err
}

const upsertPeerRole = `-- name: UpsertPeerRole :exec
INSERT INTO peers.peers_roles (
    peer_id,
    role
) VALUES ($1, $2)
`

type UpsertPeerRoleParams struct {
	PeerID string
	Role   PeersRole
}

func (q *Queries) UpsertPeerRole(ctx context.Context, arg *UpsertPeerRoleParams) error {
	_, err := q.db.Exec(ctx, upsertPeerRole, arg.PeerID, arg.Role)
	return err
}
